/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_HASH_H__
#define __TR_HASH_H__

#include <sys/types.h>

#include "trbase.h"
#include "tr/tree.h"

#define TR_HASH_IS_EMPTY(h)	((h)->tree->root)

TR_CLASS(TR_Hash) {
	TR_Tree tree;
	int     cleanup_no_free;
};
TR_INSTANCE_INIT(TR_Hash);
TR_CLASSVARS_DECL(TR_Hash) {};

//#define TR_hashEmpty(hash) (NULL == (hash)->tree->root)

void          * TR_hashAdd(TR_Hash, void *);
void          * TR_hashDelete(TR_Hash, const char *, size_t);
void          * TR_hashGet(TR_Hash, const char *, size_t);
void          * TR_hashGetFirst(TR_Hash);
void          * TR_hashDeleteByVal(TR_Hash, unsigned long);
void          * TR_hashGetByVal(TR_Hash, unsigned long);
unsigned long   TR_hashEach(TR_Hash, const void *, void (*)(const void *, const void *));
void            TR_hashCleanup(TR_Hash);

#endif // __TR_HASH_H__

// vim: set ts=4 sw=4:
