/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_INTERFACE_HASHABLE_H__
#define __TR_INTERFACE_HASHABLE_H__

#include "trbase.h"

typedef unsigned long (* fptr_TR_hashableGetHash)(void *);
typedef void          (* fptr_TR_hashableHandleDouble)(void *, void *);

TR_INTERFACE(TR_Hashable) {
	TR_IFID;
	fptr_TR_hashableGetHash      getHash;
	fptr_TR_hashableHandleDouble handleDouble;
};

inline
unsigned long
TR_hashableGetHash(void * hashable)
{
	unsigned long ret;
	TR_RETCALL(hashable, TR_Hashable, getHash, ret);
	return ret;
}

inline
void
TR_hashableHandleDouble(void * hashable, void * new_hashable)
{
	TR_CALL(hashable, TR_Hashable, handleDouble, new_hashable);
}

#endif // __TR_INTERFACE_HASHABLE_H__

// vim: set ts=4 sw=4:
