/**
 * \file
 * Holds requests ready for processing.
 *
 * \todo change this to a real queue.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_LIST_H__
#define __TR_LIST_H__

#include <sys/types.h>

#include "trbase.h"


TR_CLASS(TR_List) {
	size_t    size;
	size_t    start;
	size_t    end;
	void   ** data;
	int       free_msgs;

	// for iterable interface
	size_t    current;
};
TR_INSTANCE_INIT(TR_List);
TR_CLASSVARS_DECL(TR_List) {};

void    TR_listPut(TR_List, void *);
void    TR_listPutFirst(TR_List, void *);
void *  TR_listGet(TR_List);
void *  TR_listGetFirst(TR_List);
ssize_t TR_listFind(TR_List, void *);
void    TR_listDelete(TR_List, void *);

#define TR_listEmpty(this)		(this->start == this->end)
#define TR_listFirst(this)		((this)->start)
#define TR_listLast(this)		((this)->end - 1)
#define TR_listSize(this)		((this)->size)

#endif // __TR_LIST_H__

// vim: set ts=4 sw=4:
