/**
 * \file
 * Holds requests ready for processing.
 *
 * \todo change this to a real queue.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_QUEUE_H__
#define __TR_QUEUE_H__

#include <sys/types.h>

#include "trbase.h"
#include "tr/list.h"


TR_CLASS(TR_Queue) {
	TR_EXTENDS(TR_List);
};
TR_INSTANCE_INIT(TR_Queue);
TR_CLASSVARS_DECL(TR_Queue) {};


#define TR_queueEmpty(this)     (TR_listEmpty(((TR_List)(this))))
#define TR_queueSize(this)      (TR_listSize(((TR_List)(this))))
#define TR_queuePut(this, data) (TR_listPut(((TR_List)(this)), (data)))
#define TR_queuePutFirst(this, data) \
	(TR_listPutFirst(((TR_List)(this)), (data)))
#define TR_queueGet(this)       (TR_listGetFirst(((TR_List)(this))))

#endif // __TR_QUEUE_H__

// vim: set ts=4 sw=4:
