/**
 * \file
 * Holds requests ready for processing.
 *
 * \todo change this to a real queue.
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_SET_H__
#define __TR_SET_H__

#include <sys/types.h>

#include "trbase.h"


TR_CLASS(TR_Set) {
	size_t    size;
	size_t    used;
	void   ** data;
	int       free_msgs;

	// for iterable interface
	size_t    current;
};
TR_INSTANCE_INIT(TR_Set);
TR_CLASSVARS_DECL(TR_Set) {};

void   TR_setAdd(TR_Set, void *);
size_t TR_setFind(TR_Set, void *);
void   TR_setDelete(TR_Set, void *);

#define TR_setEmpty(this)		(this->used == 0)
#define TR_setSize(this)		((this)->used)

#endif // __TR_SET_H__

// vim: set ts=4 sw=4:
