/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <sys/types.h>
#include <string.h>
#include <errno.h>

#include "tr/cbuf.h"

char *
TR_cbufSetData(TR_Cbuf this, const void * src, size_t n)
{
	char * addr;

	if (n > TR_cbufGetFree(this)) {
		errno = TR_ECBUFOVFL;
		return (char *)-1;
	}

	addr = memcpy(TR_cbufGetWrite(this), src, n);
	TR_cbufIncWrite(this, n);

	return addr;
}

// vim: set ts=4 sw=4:
