/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <search.h>

#include "tr/hash.h"
#include "tr/tree.h"

static void (*cb)(const void*, const void*);

static
void
walk(const void * node, const void * data, const int depth)
{
	cb(node, data);
}

unsigned long
TR_hashEach(
		TR_Hash this,
		const void * data,
		void (*callback)(const void *, const void *))
{
	cb = callback;

	return TR_treeWalk(this->tree, data, walk);
}

// vim: set ts=4 sw=4:
