/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __TR_LIST_RESIZE_H__
#define __TR_LIST_RESIZE_H__

#include "trbase.h"
#include "tr/list.h"

inline
void
_TR_listResize(TR_List this, size_t split)
{
#define VPSIZE(elem)	((elem) * sizeof(void*))

	void   ** new      = TR_malloc(VPSIZE(this->size + 1));
	size_t    new_size = TR_getUsableSize(new) / sizeof(void *);

#define GROWTH	(new_size - this->size)

	memcpy(new, this->data, VPSIZE(split));
	memcpy(
			new + GROWTH + this->start,
			&(this->data[this->start]),
			VPSIZE(this->size - this->start));
	this->start = GROWTH + this->start;
	this->size  = new_size;
	TR_MEM_FREE(this->data);
	this->data  = new;
}

#endif // __TR_LIST_RESIZE_H__

// vim: set ts=4 sw=4:
