/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "tr/list.h"

#include "_resize.h"

ssize_t
TR_listFind(TR_List this, void * msg)
{
	/*
	 * With an array I know no better way than doing it in O(n).
	 * The list pattern needs to keep the elements in the order in
	 * which they were added.
	 */
	size_t i = this->start;
	while (i++ < this->end) {
		if (this->data[i] == msg) {
			return i;
		}
	}
	return -1;
}

// vim: set ts=4 sw=4:
