/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "tr/list.h"

#include "_resize.h"

extern inline void _TR_listResize(TR_List, size_t);

void
TR_listPut(TR_List this, void * msg)
{
	this->data[this->end] = msg;
	this->end = this->end + 1 == this->size ? 0 : this->end + 1;

	if (this->end == this->start) {
		_TR_listResize(this, this->end);
	}
}

// vim: set ts=4 sw=4:
