/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdarg.h>

#include "trbase.h"
#include "tr/queue.h"
#include "tr/list.h"

static
int
queueCtor(void * _this, va_list * params)
{
	TR_PARENTCALL(TR_Queue, _this, TR_Class, ctor, params);
	return 0;
}

static
void
queueDtor(void * _this)
{
	TR_PARENTCALL(TR_Queue, _this, TR_Class, dtor);
}

TR_INIT_IFACE(TR_Class, queueCtor, queueDtor, NULL);
TR_CREATE_CLASS(TR_Queue, TR_List, NULL, TR_IF(TR_Class));

// vim: set ts=4 sw=4:
