/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "tr/set.h"

#include "_resize.h"

extern inline void _TR_setResize(TR_Set);

void
TR_setAdd(TR_Set this, void * msg)
{
	size_t pos = TR_setFind(this, msg);

	if (this->data[pos] == msg) {
		return;
	}

	if (this->used == this->size) {
		_TR_setResize(this);
	}

	if (pos != this->used) {
		memmove(
				this->data+pos+1,
				this->data+pos,
				(this->used-pos)*sizeof(void*));
	}

	this->data[pos] = msg;
	++this->used;
}

// vim: set ts=4 sw=4:
