/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "tr/set.h"

size_t
TR_setFind(TR_Set this, void * search)
{
#define MID(a, b)	(((b)-(a))/2)

	size_t start = 0;
	size_t end   = this->used > 0 ? this->used-1 : 0;
	size_t i     = MID(start, end);

	while (this->data[i] != search && start < end) {
		if (this->data[i] < search) {
			start = i+1 > end ? end : i+1;
		} else {
			end = i <= start || i-1 < start ? start : i-1;
		}
		i = start+MID(start, end);
	}

	if (this->data[i] < search && this->used != 0) ++i;

	return i;
}

// vim: set ts=4 sw=4:
