/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define _GNU_SOURCE

#include <stdarg.h>

#include "trbase.h"
#include "tr/tree.h"

static
int
treeNodeCtor(void * _this, va_list * params)
{
	TR_TreeNode this = _this;

	this->data   = va_arg(*params, void *);
	this->color  = rbRed;
	this->parent = NULL;
	this->left   = NULL;
	this->right  = NULL;

	return 0;
}

static void treeNodeDtor(void * _this) {}

TR_INIT_IFACE(TR_Class, treeNodeCtor, treeNodeDtor, NULL);
TR_CREATE_CLASS(TR_TreeNode, NULL, NULL, TR_IF(TR_Class));

// vim: set ts=4 sw=4:
